/* Appunti sull’utilizzo di FileOutputStream in Java
FileOutputStream si usa per scrivere data/streams dei bytes su un file. 
FileOutputStream e' una sottoclasse di OutputStream. 
il costruttore di FileOutputStream FileOutputStream(file, boolean append): 
FileOutputStream scrivifile = new FileOutputStream("esempio.txt", false); per creare un file eliminandolo se già esistente
FileOutputStream scrivifile = new FileOutputStream("esempio.txt", true); per agiungere dati al file senza camncellarlo
*/
package filetext2;
import java.io.*; // importiamo tutte le librerie 

public class FileText2 {

    public static void main(String[] args) {
// scriviamo singole lettere sul file partendo da una stringa
   try{
        FileOutputStream scrivifile = new FileOutputStream("c:/EsempioFile.txt",false); // create a fileoutputstream object
        String st = "CLASSE 4 a Informatica."; // creiamo una stringa ed inseriamo una frase in essa
        char lettera[] = st.toCharArray(); // trasformiamo la stringa in caratteri singoli che vanno nella variabile[vettore] lettera
        for (int i = 0; i < st.length(); i++) // scriviamo la stringa carattere per carattere sul file (1 carattere alla volta)
            { 
            scrivifile.write(lettera[i]);
            }
        scrivifile.close(); // il salvataggio su disco avviene quando chiudiamo il file
      }
         catch (IOException e){ System.out.println("Eccezione: " + e);
          }
   // scriviamo adesso il vettore di lettere sul file sempre partendo da una stringa senza usa il for per convertire le singole lettere
        String frase = "La classe e' in paletra "; // creiamo una stringa ed inseriamo una frase in essa ache fuori dal try-catch
   try{
        FileOutputStream scrivifile = new FileOutputStream("C:/EsempioFile.txt",true); // aggiungiamo quello che stiamo per scrivere al file
        byte[] lettere = frase.getBytes(); // trasforma la stringa in un vettore di caratteri di tipo bytes. getBytes() è un metodo
        scrivifile.write(lettere); // scriviamo il vettore di nume lettere sul file con il metodo write() 
        scrivifile.write(13); // si usa per andare a capo caratteri 13 e poi 10 (line feed e carriage return
        scrivifile.write(10);
        scrivifile.close();
      }
         catch (IOException e){ System.out.println("Eccezione: " + e);}
    // scriviamo sul file direttamente la stringa usando la classe OutputStreamWriter:
        String terzariga = "per adesso si sta bene "; // creiamo una stringa ed inseriamo una frase in essa ache fuori dal try-catch
   try{
        FileOutputStream scrivifile = new FileOutputStream("C:/EsempioFile.txt",true); // aggiungiamo quello che stiamo per scrivere al file
        Writer scrividiretto = new OutputStreamWriter(scrivifile); // si usa la classe OutputStreamWriter
        scrividiretto.write(terzariga); // scriviamo la stringa su disco 
        scrividiretto.close();
      }
         catch (IOException e){ System.out.println("Eccezione: " + e);}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * 
 * LETTURA DEL FILE  
  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
// LEGGIAMO UN CARATTERE     
    System.out.println("Leggo la prima lettera sul file:");    
     try{    
            FileInputStream leggi=new FileInputStream("C:/EsempioFile.txt"); // si apre il file in lettura, la macchina si posiziona all'inizio del file
            int i=leggi.read();  // il primo byte letto va nella variabile i
            System.out.println((char)i); // si stampa il valore char del carattere letto com e intero
            leggi.close(); // si chiude il file senza leggere altro
          }catch(Exception e){System.out.println(e);}    
            
// LEGGIAMO DUE CARATTERI
    System.out.println("Leggo DUE lettere dal file:");    
    int i;
     try{    
            FileInputStream leggi=new FileInputStream("C:/EsempioFile.txt");  // si apre il file in lettura, la macchina si posiziona all'inizio del file  
            i=leggi.read();  // il primo byte letto va nella variabile i
            System.out.print((char)i);    
            i=leggi.read();  // adesso legge il secondo  byte e va sempre nella variabile i
            System.out.println((char)i);    
            leggi.close();    
          }catch(Exception e){System.out.println(e);}    

// LEGGIAMO TUTTO IL FILE (ricordiamoci che quando non trova altro da leggere (eof) restituisce -1 come valore intero
   System.out.println("METODO 1 - Stampo tutto il contenuto del file: ");         
     try{    
            FileInputStream leggi=new FileInputStream("C:/EsempioFile.txt");    
            int r= leggi.read(); // si dichiara r intera e si rende uguale al primo byte del file
            while(r!=-1){    
             System.out.print((char)r);    
             r= leggi.read(); // si legge un nuovo byte dal disco
            }    
            leggi.close();    
            
          }catch(Exception e){System.out.println(e);}    
            

     
// LEGGIAMO TUTTO IL FILE (ricordiamoci che quando non trova altro da leggere (eof) restituisce -1 come valore intero
System.out.println();   
System.out.println("METODO 2 - Stampo tutto il contenuto del file:");         
     try{    
            FileInputStream leggi=new FileInputStream("C:/EsempioFile.txt");    
            int l=0; // si dichiara l intera e si rende uguale a 0
            while((l=leggi.read())!=-1){    
             System.out.print((char)l);    
            }    
            leggi.close();    
          }catch(Exception e){System.out.println(e);}    
         }    
   
    
    
    }        

   
       
   
    }
